#include <bits/stdc++.h>
using namespace std;
string s;
int n, q, a, b;
int main(){
    cin >> n >> q >> s;
    while(q--){
        cin >> a >> b;
        int duz = b-a+1;
        if(duz%2==0){
            cout << duz*duz/4 << endl;
        }
        else{
           cout << duz/2*((duz+1)/2) << endl;
        }

    }
    return 0;
}